      PROGRAM ANA_TS1_P ! Bernd Berg, Sep 13 2008. Single time series.
C Potts model, prepares plot for t-dependent integrated 
C autocorrelation time. Calculates the average energy (action).
C Copies all NRPT segments into a single time series. Should be used 
C when NT is too large to be calculated in a time C series section of 
C length NMEAS, or to check on bias. Otherwise ana_ts_p.f is simpler.
      INCLUDE '../../Libs/Fortran/implicit.sta'
      CHARACTER CD*1,CQ*2,CL*3
      INCLUDE '../../Libs/Fortran/constants.par'
      INCLUDE 'lat.par'
      INCLUDE 'mc.par'
      INCLUDE 'potts.par'
C For autocorrelation calculations:
C NT     Maximum time distance considered.
C NBINS  Number of bins used for jackknife. Can be NRPT or different.
C NSKIP  Number of data skipped in each step of the analysis. Reduces 
C        the length of the time series by 1/(NSKIP+1).
C NSTEP  Stepsize used in the data file for the plot.
      PARAMETER(NT=2**06,NBINS=NRPT,NSKIP=0,NSTEP=2**0,LMEAN=.TRUE.)
      PARAMETER(NSKP1=NSKIP+1)
      INCLUDE '../../Libs/Fortran_par/common_lat.f'
      INCLUDE '../../Libs/Fortran_par/common_potts.f'
      DIMENSION ACORJ(NBINS,0:NT),ACOR(0:NT),WORK(NBINS)
      DIMENSION ACINTJ(NBINS,0:NT),ACINT(0:NT),ACE(0:NT)
      INCLUDE 'lat.dat'
      DIMENSION TSA(NRPT*(NMEAS/NSKP1)),TSA_IN(NMEAS),ACT(NRPT)
      LTEST=.TRUE.
      LTEST=.FALSE.
      IF(LTEST) STOP "ANA_TS1_P: LTEST."
C
      WRITE(CD,'(I1.1)') ND ! Prepare to READ the data.
      WRITE(CQ,'(I2.2)') NQ
      WRITE(CL,'(I3.3)') NLA(1)
      OPEN(IUD1,file="p"//CQ//"_"//CD//"d"//CL//".D",
     &          form="unformatted",status="old")
      READ(IUD1) BETA_IN,ND_IN,NQ_IN,NLA,NLINK,NEQUI_IN,NRPT_IN,
     &           NMEAS_IN,NSW_IN
      WRITE(IUO,'(/," beta,nlink,nd,nla:",F15.10,I10,I3,2X,4I5)')
     &                BETA,NLINK,ND_IN,NLA
      WRITE(IUO,'(" nequi,nrpt,nmeas: ",I15,2I10)')
     &              NEQUI_IN,NRPT_IN,NMEAS_IN
      IF(ND.NE.ND_IN) STOP "nd.ne.nd_in."
      IF(NQ.NE.NQ_IN) STOP "nq.ne.nq_in."
      IF(NEQUI.NE.NEQUI_IN) STOP "nequi.ne.nequi_in."
      IF(NRPT.NE.NRPT_IN) STOP "nrpt.ne.nrpt_in."
      IF(NMEAS.NE.NMEAS_IN) STOP "nmeas.ne.nmeas_in."
      NDAT=0
      DO IRPT=1,NRPT
        READ(IUD1) HA,TSA_IN,ACPT,I_IN
        DO IMEAS=1,NMEAS,NSKP1 ! Stepsize NSKIP+1.
          NDAT=NDAT+1
          TSA(NDAT)=TSA_IN(IMEAS)
        ENDDO
        ACT(IRPT)=STMEAN(NMEAS,TSA_IN)
      ENDDO
      CLOSE(IUD1)
      WRITE(IUO,'(" NDAT =",i16)') NDAT
C
      CALL STEB0(NRPT,ACT,ACTm,ACTv,ACTe)
      WRITE(IUO,'(" ACTm =",F15.10," +/-",F15.10)') ACTm,ACTe
      WRITE(IUO,'(" em =  ",F15.10," +/-",F15.10)') (-2*ACTm),(2*ACTe)

      DO IT=0,NT
        ACOR(IT)=AUTCORF(IT,NDAT,TSA,LMEAN)
        CALL AUTCORJ(IT,NDAT,NBINS,TSA,WORK,ACORJ(1,IT),LMEAN)
        CALL STEBJ0(NBINS,ACORJ(1,IT),ACM,ACV,ACE(IT))
        CALL WRITE_PROGRESS(IUD2,"IT,NT,ACM:",IT,NT,ACM)
      END DO
C
      OPEN(IUD1,file="1a"//CQ//"_"//CD//"d"//CL//".d",
     &          form="formatted",status="unknown")
      CALL AC_INT(NT,ACOR,ACINT)
      CALL AC_INTJ(NT,NBINS,ACORJ,ACINTJ)
      LMONOTON=.TRUE.
      TAU_INT=ZERO
      DO IT=0,NT,NSTEP
        CALL STEBJ0(NBINS,ACINTJ(1,IT),ACM,ACV,ACE(IT))
        BIAS=(NBINS-1)*ABS(ACINT(IT)-ACM) ! Bias: Compare with
        ITT=NSKP1*NSW*IT                  ! signal and error bar.
        ACINT(IT)=NSKP1*NSW*ACINT(IT)
        ACE(IT)=NSKP1*NSW*ACE(IT)
        BIAS=NSKP1*NSW*BIAS
        WRITE(IUD1,'(I6,3G15.6)') ITT,ACINT(IT),ACE(IT),BIAS
        IF(LMONOTON) THEN
          IF(ACINT(IT).GE.TAU_INT) THEN
            TAU_INT=ACINT(IT)
            TAU_INTE=ACE(IT)
            EBIAS=BIAS ! Estimate of bias at ITTEST.    
            ITTEST=NSKP1*NSW*IT
          ELSE
            LMONOTON=.FALSE. 
          ENDIF
        ENDIF
      END DO
      CLOSE(IUD1)
      WRITE(IUO,*) "Autocorrelation times are on the 1a*.d file."
      WRITE(IUO,'(2X,
     &  "Bias is in 3rd column. Estimates are NOT bias-corrected.")')
      WRITE(IUO,'(2X,"Plot with tau_int.plt and extract estimate.")')
      WRITE(IUO,'(/,2X,"A somewhat unreliable automatic pick: ITTMAX =",
     &            I10,/)') (NSKP1*NSW*NT)
      WRITE(IUO,'(5X,"ITTEST",4X,"TAU_INT",7X,"TAU_INTE",10X,"BIAS")')
      WRITE(IUO,'(/,I10,3G15.6)') ITTEST,TAU_INT,TAU_INTE,EBIAS
      WRITE(IUO,'(10X,1G15.6," bias-corrected.",/)') (TAU_INT+EBIAS)
C
      STOP
      END

      INCLUDE '../../Libs/Fortran/ac_int.f'
      INCLUDE '../../Libs/Fortran/ac_intj.f'
      INCLUDE '../../Libs/Fortran/autcorf.f'
      INCLUDE '../../Libs/Fortran/autcorj.f'
      INCLUDE '../../Libs/Fortran/bias.f'
      INCLUDE '../../Libs/Fortran/bining.f'
      INCLUDE '../../Libs/Fortran/datjack.f'
      INCLUDE '../../Libs/Fortran/steb0.f'
      INCLUDE '../../Libs/Fortran/stebj0.f'
      INCLUDE '../../Libs/Fortran/stmean.f'
      INCLUDE '../../Libs/Fortran/write_progress.f'

